[build-system]
requires = ['setuptools']
build-backend = 'setuptools.build_meta'

[project]
name = 'mxxn'
description = 'The MXXN web application framework'
version = '0.1.0'
license = {text = 'AGPLv3'}
requires-python = '>3.10'

dependencies = [
	'falcon>=3.0',
	'uvicorn[standard]',
	'pydantic',
	'jsonschema',
	'jinja2',
	'sqlalchemy>=2.0',
	'alembic',
	'aiosqlite',
	'tomli',
	'tomli_w'
]

[project.scripts]
mxxr = 'mxxn.cli:main'

[project.optional-dependencies]
develop = [
	'coverage[toml]',
	'pytest>=6.0',
	'pytest-cov',
	'flake8',
	'flake8-docstrings',
	'Flake8-pyproject',
	'mypy',
	'sphinx',
	'sphinx-autoapi',
	'sphinxcontrib-httpdomain',
	'piccolo-theme',
	'types-jsonschema',
	'types-setuptools',
	'nodeenv',
	'sqlalchemy[mypy]',
	'copier',
]

gunicorn = ['gunicorn']

[tool.setuptools.packages.find]
where = ['src']

[tool.coverage]
omit = [
	'mxxn/alembic/*',
	'mxxn/cli.py'
]

[tool.flake8]
exclude = [
	'.git',
	'__pycache__',
	'build',
	'dist',
	'.undodir',
	'mxxn/alembic',
	'mxxn/models/versions'
]

[tool.mypy]
files = 'mxxn'
disallow_untyped_defs = true
plugins = 'sqlalchemy.ext.mypy.plugin'
exclude = 'mxxn/models/versions/*|mxxn/alembic/*'

[[tool.mypy.overrides]]
module = 'falcon.*'
ignore_missing_imports = true
